% script for fixed point iteration for the system
% x_1^2 + x_2^2 - 1 = 0
% 5x_1^2 + 21x_2^2 - 9 = 0
clear all; clc;

F = @(x)([x(1)^2 + x(2)^2 - 1;5*x(1)^2 + 21*x(2)^2 - 9]);
G = @(x)([sqrt(1-x(2)^2); sqrt((9-5*x(1)^2)/21)]);

x_k = [1; 1];
x_k_old = [inf; inf];

TOL = 1e-6;
step_size = norm(x_k - x_k_old);

while (step_size/norm(x_k) > TOL)
    step_size_old = step_size;
    
    x_k_old = x_k;
    x_k = G(x_k)
    
    step_size = norm(x_k - x_k_old);
end

x_exact = [sqrt(3)/2; 0.5];
fprintf('relative error is %d\n',norm(x_k - x_exact)/norm(x_exact))