% script for secant method for f(x) = exp(x) - x - 2 = 0
clear all; clc;

f = @(x)(exp(x)-x-2);

x = linspace(0,2);
plot(x,f(x),'linewidth',2);
hold on
plot(x,0*x,'k')

x_k = 1.5;
x_k_old = 2;
plot(x_k,f(x_k),'rx','markersize',14,'linewidth',2)

TOL = 1e-10;
step_size = abs(x_k - x_k_old);

while (step_size/abs(x_k) > TOL)
    x_k_new = x_k - f(x_k) * (x_k - x_k_old)/(f(x_k)-f(x_k_old));
    
    x_k_old = x_k;
    x_k = x_k_new;
    
    step_size = abs(x_k - x_k_old);
    fprintf('step size = %d\n',step_size);

    plot(x_k,f(x_k),'rx','markersize',14,'linewidth',2)
end
hold off

fprintf('root is at approx. %d, function value is %d\n',x_k,f(x_k))
